#line 1 "E:/Microcontroller Projects/Radio nRF24L01 PIC16F877A/Radio nRF24L01 PIC16F877A.c"
#line 1 "e:/microcontroller projects/radio nrf24l01 pic16f877a/nrf24l01.h"
#line 16 "E:/Microcontroller Projects/Radio nRF24L01 PIC16F877A/Radio nRF24L01 PIC16F877A.c"
const char test[] = "Test message.";





const char adr0[] = {0x78,0x78,0x78,0x78,0x78};
const char adr1[] = {0xf1,0xb4,0xb5,0xb6,0xb3};
const char adr2[] = {0xb3,0xb4,0xb5,0xb6,0xb3};
const char adr3[] = {0x83,0xb4,0xb5,0xb6,0xb3};
const char adr4[] = {0xcf,0xb4,0xb5,0xb6,0xb3};
const char adr5[] = {0x75,0xb4,0xb5,0xb6,0xb3};

char Data_In[21], Data_Out[21], stat;
short dataLength = 20;


sbit Irq_pin at PORTB.B0; sfr;
sbit Mosi_pin at PORTC.B5; sfr;
sbit Ce_pin at PORTC.B1; sfr;
sbit Sclk_pin at PORTC.B3; sfr;
sbit Csn_pin at PORTC.B2; sfr;
sbit Miso_pin at PORTC.B4; sfr;

sbit Irq_tris at TRISB.B0; sfr;
sbit Mosi_tris at TRISC.B5; sfr;
sbit Ce_tris at TRISC.B1; sfr;
sbit Sclk_tris at TRISC.B3; sfr;
sbit Csn_tris at TRISC.B2; sfr;
sbit Miso_tris at TRISC.B4; sfr;


sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;


void Comm_Delay() {Delay_us(10);}
void Delay_10() {Delay_ms(10);}
void Delay_100() {Delay_ms(100);}
void Delay_500() {Delay_ms(500);}

void Clear_Data(char dat[]){
 char i;
 for(i=0;i<dataLength;i++)dat[i] = ' ';
}

void toggleCSN(){
 Csn_pin = 1;
 Delay_us(20);
 Csn_pin = 0;
 Comm_Delay();
}

char Get_Status(){
 char s;
 Ce_pin = 0;
 toggleCSN();
 SPI1_Write( 0x07 );
 Comm_Delay();
 s = SPI1_Read( 0xFF );
 Comm_Delay();
 Csn_pin = 1;
 return s;
}

char *getConst(char dest[], const char source[]){
 int i = 0;
 while (source[i])
 {dest[i] = source[i]; i++;}
 dest[i] = '\0';
 return dest;
}

char Get_FIFO_Flags(){
 char s;
 Ce_pin = 0;
 toggleCSN();
 SPI1_Write( 0x17 );
 Comm_Delay();
 s = SPI1_Read( 0xFF );
 Comm_Delay();
 Csn_pin = 1;
 return s;
}

void makeMsg(){
 Clear_Data(Data_Out);
 getConst(Data_Out, test);
}

char readBuffer(){
 char i, s;
 Ce_pin = 0;
 Clear_Data(Data_In);
 s = Get_FIFO_Flags();
 if((s & 2) != 0){
 toggleCSN();
 SPI1_Write( 0x61 );
 for(i=0; i < dataLength; i++){Comm_Delay(); Data_In[i] = SPI1_Read(0);}
 Comm_Delay();
 }
 Csn_pin = 1;
 Ce_pin = 1;
 return s;
}

void sendBuffer(){
 char i, j;
 do{
 toggleCSN();
 SPI1_Write( 0x07  |  0x20 );
 Comm_Delay();
 SPI1_Write(0xff);
 Comm_Delay();
 toggleCSN();
 SPI1_Write( 0xE1 );
 Comm_Delay();
 toggleCSN();
 SPI1_Write( 0xA0 );
 for(i = 0; i < dataLength; i++) {Comm_Delay(); SPI1_Write(Data_Out[i]);}
 Comm_Delay();
 Csn_pin = 1;
 Ce_pin = 1;
 Delay_10();
 j = (Get_Status() & 0x20);
 }while(j==0);
}

char init_Radio(){
 char i;
 Ce_pin = 0;
 Comm_Delay();
 toggleCSN();
 SPI1_Write( 0x00  |  0x20 );
 Comm_Delay();
#line 179 "E:/Microcontroller Projects/Radio nRF24L01 PIC16F877A/Radio nRF24L01 PIC16F877A.c"
 SPI1_Write( 0x02  +  0x04  +  0x08 );
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x01  |  0x20 );
 Comm_Delay();
 SPI1_Write( 0x01 );
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x02  |  0x20 );
 Comm_Delay();
 SPI1_Write( 0x01 );
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x0A  |  0x20 );
 for(i=0;i<5;i++){Comm_Delay(); SPI1_Write(adr0[i]);}
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x10  |  0x20 );
 for(i=0;i<5;i++){Comm_Delay(); SPI1_Write(adr0[i]);}
 Comm_Delay();


 toggleCSN();
 SPI1_Write( 0x03  |  0x20 );
 Comm_Delay();
 SPI1_Write( 0x03 );
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x04  |  0x20 );
 Comm_Delay();
 SPI1_Write(0xfaf);
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x05  |  0x20 );
 Comm_Delay();
 SPI1_Write(83);
 Comm_Delay();

 toggleCSN();
 SPI1_Write( 0x06  |  0x20 );
 Comm_Delay();
 SPI1_Write( 0x06  +  0x01 );
 Comm_Delay();
#line 296 "E:/Microcontroller Projects/Radio nRF24L01 PIC16F877A/Radio nRF24L01 PIC16F877A.c"
 toggleCSN();
 SPI1_Write( 0x11  |  0x20 );
 Comm_Delay();
 SPI1_Write(dataLength);
 Comm_Delay();

 Csn_pin = 1;
 i = Get_Status();
 return i;
}




void main(){
 char txt[5], dat1;
 ADCON1 = 0x04;
 CMCON = 7;



 Csn_tris = 0;
 Csn_pin = 1;
 Ce_tris = 0;
 Ce_pin = 0;

 SPI1_Init();

 Delay_ms(200);
 stat = init_Radio();


 Clear_Data(Data_Out);


 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 1, "nRF24L01+");
 ByteToHex(stat, txt);
 Lcd_Out(2, 1, txt);
 Delay_500();

 do {
 dat1 = 0;
 Lcd_Cmd(_LCD_CLEAR);

 dat1 = Get_Status();
 ByteToHex(dat1, txt);
 Delay_10();
 Lcd_Out(1, 6, txt);
 dat1 = Get_FIFO_Flags();
 ByteToHex(dat1, txt);
 Delay_10();
 Lcd_Out(1, 11, txt);


 Lcd_Out(1, 1, "TX");
 Lcd_Out(2, 1, Data_Out);
 Delay_100();
 makeMsg();
 sendBuffer();
 Delay_100();
#line 371 "E:/Microcontroller Projects/Radio nRF24L01 PIC16F877A/Radio nRF24L01 PIC16F877A.c"
 }while(1);
}
